#!/bin/sh
#(c) 2005 Robert Shingledecker
#09 Jan 2005
#
. /etc/init.d/dsl-functions
#
export PATH="$PATH:."
echo
echo "${RED}DSL USB pendrive ${WHITE}5-way installation ${BLUE}utility.${NORMAL}"
echo "${YELLOW}No responsibility for data loss or hardware damage!${NORMAL}"
echo "Your pendrive must have a vfat partition visibile to DSL."
echo "This usually means 32 sector/track and not more than 1024 cyclinders."
echo "Use cfdisk to accomplish this task. (See readme.txt)"
echo "DO NOT have your pendrive mounted."
echo -n "${CYAN}Ready to proceed (y/..)?${NORMAL} "
read answer
if [ "$answer" != "y" ]; then
  echo "Aborted.."
  exit 0
fi
if [ ! -f dsl-embedded.zip ]; then
   echo "${BLUE}Standby fetching the embedded zip file...${NORMAL}"
   wget ftp://www.ibiblio.org/pub/Linux/distributions/damnsmall/current/dsl-embedded.zip
   if [ $? != 0 ]; then
      echo "${RED}Error while trying to fetch the embedded zip file.${NORMAL}"
      rm -f dsl-embedded
      echo "Script is terminating..."
      exit 1
   fi
fi
# read target partition from user
echo -n "${CYAN}Enter the target device to hold image ${WHITE}(EXAMPLE: ${YELLOW}sda1): ${NORMAL}" 
read USB
if [ -z "$USB" ] ; then
  echo "No device chosen. The script will be terminated."
  exit 1
fi    
#
echo "${RED}Last change to exit before destroying all data on ${MAGENTA}/dev/$USB${NORMAL}"
echo -n "${CYAN}Continue (y/..)?${NORMAL} "
read answer
if [ "$answer" != "y" ]; then
  echo "Aborted.."
  exit 0
fi
echo
echo "${BLUE}Formatting ${MAGENTA}/dev/$USB${NORMAL}"
umount /mnt/$USB
./mkdosfs /dev/$USB
if [ $? != 0 ]; then
   echo "Error creating DOS filesystem."
   exit 1
fi
echo "${BLUE}Unpacking embedded zip file.${NORMAL}"
if [ ! -d ]; then mkdir 5-way_install; fi
./unzip -q dsl-embedded -d 5-way_install

echo -n "${BLUE}Setting up system image on ${MAGENTA}/mnt/$USB${NORMAL}..."
mount -t vfat /dev/$USB /mnt/$USB
if [ $? != 0 ]; then
   echo "Error mounting usb device"
   exit 1
fi
cd 5-way_install
cp -R * /mnt/$USB &
rotdash $!
sync
cd ..
echo " Done."
umount /mnt/$USB
rm -rf 5-way_install
sync
echo "${BLUE}Setting up boot loader on ${MAGENTA}/mnt/$USB${NORMAL}"
echo "mtools_skip_check=1" > ~/.mtoolsrc
./syslinux -s /dev/$USB
if [ $? != 0 ]; then
   echo "Error writing boot sector"
   exit 1
fi
echo "${GREEN} USB 5-way installation has completed${NORMAL}"
rm -f dsl-embedded.zip
